Bullet Collision Detection & Physics Library: btMultiBodySliderConstraint Class Reference

Bullet Collision Detection & Physics Library

Public Member Functions | Protected Attributes | List of all members
btMultiBodySliderConstraint Class Reference

This file was written by Erwin Coumans. More...

`#include <btMultiBodySliderConstraint.h>`

Inheritance diagram for btMultiBodySliderConstraint:
[legend]
Collaboration diagram for btMultiBodySliderConstraint:
[legend]

## Public Member Functions
| btMultiBodySliderConstraint (btMultiBody *body, int link, btRigidBody *bodyB, const btVector3 &pivotInA, const btVector3 &pivotInB, const btMatrix3x3 &frameInA, const btMatrix3x3 &frameInB, const btVector3 &jointAxis)
| btMultiBodySliderConstraint (btMultiBody *bodyA, int linkA, btMultiBody *bodyB, int linkB, const btVector3 &pivotInA, const btVector3 &pivotInB, const btMatrix3x3 &frameInA, const btMatrix3x3 &frameInB, const btVector3 &jointAxis)
virtual | ~btMultiBodySliderConstraint ()
virtual void | finalizeMultiDof ()
virtual int | getIslandIdA () const
virtual int | getIslandIdB () const
virtual void | createConstraintRows (btMultiBodyConstraintArray &constraintRows, btMultiBodyJacobianData &data, const btContactSolverInfo &infoGlobal)
const btVector3 & | getPivotInA () const
void | setPivotInA (const btVector3 &pivotInA)
const btVector3 & | getPivotInB () const
virtual void | setPivotInB (const btVector3 &pivotInB)
const btMatrix3x3 & | getFrameInA () const
void | setFrameInA (const btMatrix3x3 &frameInA)
const btMatrix3x3 & | getFrameInB () const
virtual void | setFrameInB (const btMatrix3x3 &frameInB)
const btVector3 & | getJointAxis () const
void | setJointAxis (const btVector3 &jointAxis)
virtual void | debugDraw (class btIDebugDraw *drawer)
Public Member Functions inherited from btMultiBodyConstraint
| BT_DECLARE_ALIGNED_ALLOCATOR ()
| btMultiBodyConstraint (btMultiBody *bodyA, btMultiBody *bodyB, int linkA, int linkB, int numRows, bool isUnilateral)
virtual | ~btMultiBodyConstraint ()
void | updateJacobianSizes ()
void | allocateJacobiansMultiDof ()
int | getNumRows () const
btMultiBody * | getMultiBodyA ()
btMultiBody * | getMultiBodyB ()
void | internalSetAppliedImpulse (int dof, btScalar appliedImpulse)
btScalar | getAppliedImpulse (int dof)
btScalar | getPosition (int row) const
void | setPosition (int row, btScalar pos)
bool | isUnilateral () const
btScalar * | jacobianA (int row)
const btScalar * | jacobianA (int row) const
btScalar * | jacobianB (int row)
const btScalar * | jacobianB (int row) const
btScalar | getMaxAppliedImpulse () const
void | setMaxAppliedImpulse (btScalar maxImp)
virtual void | setGearRatio (btScalar ratio)
virtual void | setGearAuxLink (int gearAuxLink)
virtual void | setRelativePositionTarget (btScalar relPosTarget)
virtual void | setErp (btScalar erp)

## Protected Attributes
btRigidBody * | m_rigidBodyA
btRigidBody * | m_rigidBodyB
btVector3 | m_pivotInA
btVector3 | m_pivotInB
btMatrix3x3 | m_frameInA
btMatrix3x3 | m_frameInB
btVector3 | m_jointAxis
Protected Attributes inherited from btMultiBodyConstraint
btMultiBody * | m_bodyA
btMultiBody * | m_bodyB
int | m_linkA
int | m_linkB
int | m_numRows
int | m_jacSizeA
int | m_jacSizeBoth
int | m_posOffset
bool | m_isUnilateral
int | m_numDofsFinalized
btScalar | m_maxAppliedImpulse
btAlignedObjectArray< btScalar > | m_data

## Additional Inherited Members
Protected Member Functions inherited from btMultiBodyConstraint
void | applyDeltaVee (btMultiBodyJacobianData &data, btScalar *delta_vee, btScalar impulse, int velocityIndex, int ndof)
btScalar | fillMultiBodyConstraint (btMultiBodySolverConstraint &solverConstraint, btMultiBodyJacobianData &data, btScalar *jacOrgA, btScalar *jacOrgB, const btVector3 &constraintNormalAng, const btVector3 &constraintNormalLin, const btVector3 &posAworld, const btVector3 &posBworld, btScalar posError, const btContactSolverInfo &infoGlobal, btScalar lowerLimit, btScalar upperLimit, bool angConstraint=false, btScalar relaxation=1.f, bool isFriction=false, btScalar desiredVelocity=0, btScalar cfmSlip=0)

## Detailed Description

This file was written by Erwin Coumans.

Definition at line 23 of file btMultiBodySliderConstraint.h.

## Constructor & Destructor Documentation

## ◆ btMultiBodySliderConstraint() [1/2]

btMultiBodySliderConstraint::btMultiBodySliderConstraint | ( | btMultiBody * | body,
|  | int | link,
|  | btRigidBody * | bodyB,
|  | const btVector3 & | pivotInA,
|  | const btVector3 & | pivotInB,
|  | const btMatrix3x3 & | frameInA,
|  | const btMatrix3x3 & | frameInB,
|  | const btVector3 & | jointAxis
| ) |  |

Definition at line 27 of file btMultiBodySliderConstraint.cpp.

## ◆ btMultiBodySliderConstraint() [2/2]

btMultiBodySliderConstraint::btMultiBodySliderConstraint | ( | btMultiBody * | bodyA,
|  | int | linkA,
|  | btMultiBody * | bodyB,
|  | int | linkB,
|  | const btVector3 & | pivotInA,
|  | const btVector3 & | pivotInB,
|  | const btMatrix3x3 & | frameInA,
|  | const btMatrix3x3 & | frameInB,
|  | const btVector3 & | jointAxis
| ) |  |

Definition at line 40 of file btMultiBodySliderConstraint.cpp.

## ◆ ~btMultiBodySliderConstraint()

btMultiBodySliderConstraint::~btMultiBodySliderConstraint | ( |  | ) |
| virtual

Definition at line 59 of file btMultiBodySliderConstraint.cpp.

## Member Function Documentation

## ◆ createConstraintRows()

void btMultiBodySliderConstraint::createConstraintRows | ( | btMultiBodyConstraintArray & | constraintRows,
|  | btMultiBodyJacobianData & | data,
|  | const btContactSolverInfo & | infoGlobal
| ) |  |
| virtual

Implements btMultiBodyConstraint.

Definition at line 103 of file btMultiBodySliderConstraint.cpp.

## ◆ debugDraw()

void btMultiBodySliderConstraint::debugDraw | ( | class btIDebugDraw * | drawer | ) |
| virtual

Implements btMultiBodyConstraint.

Definition at line 200 of file btMultiBodySliderConstraint.cpp.

## ◆ finalizeMultiDof()

void btMultiBodySliderConstraint::finalizeMultiDof | ( |  | ) |
| virtual

Implements btMultiBodyConstraint.

Definition at line 53 of file btMultiBodySliderConstraint.cpp.

## ◆ getFrameInA()

const btMatrix3x3& btMultiBodySliderConstraint::getFrameInA | ( |  | ) | const
| inline

Definition at line 71 of file btMultiBodySliderConstraint.h.

## ◆ getFrameInB()

const btMatrix3x3& btMultiBodySliderConstraint::getFrameInB | ( |  | ) | const
| inline

Definition at line 81 of file btMultiBodySliderConstraint.h.

## ◆ getIslandIdA()

int btMultiBodySliderConstraint::getIslandIdA | ( |  | ) | const
| virtual

Implements btMultiBodyConstraint.

Definition at line 64 of file btMultiBodySliderConstraint.cpp.

## ◆ getIslandIdB()

int btMultiBodySliderConstraint::getIslandIdB | ( |  | ) | const
| virtual

Implements btMultiBodyConstraint.

Definition at line 83 of file btMultiBodySliderConstraint.cpp.

## ◆ getJointAxis()

const btVector3& btMultiBodySliderConstraint::getJointAxis | ( |  | ) | const
| inline

Definition at line 91 of file btMultiBodySliderConstraint.h.

## ◆ getPivotInA()

const btVector3& btMultiBodySliderConstraint::getPivotInA | ( |  | ) | const
| inline

Definition at line 51 of file btMultiBodySliderConstraint.h.

## ◆ getPivotInB()

const btVector3& btMultiBodySliderConstraint::getPivotInB | ( |  | ) | const
| inline

Definition at line 61 of file btMultiBodySliderConstraint.h.

## ◆ setFrameInA()

void btMultiBodySliderConstraint::setFrameInA | ( | const btMatrix3x3 & | frameInA | ) |
| inline

Definition at line 76 of file btMultiBodySliderConstraint.h.

## ◆ setFrameInB()

virtual void btMultiBodySliderConstraint::setFrameInB | ( | const btMatrix3x3 & | frameInB | ) |
| inlinevirtual

Reimplemented from btMultiBodyConstraint.

Definition at line 86 of file btMultiBodySliderConstraint.h.

## ◆ setJointAxis()

void btMultiBodySliderConstraint::setJointAxis | ( | const btVector3 & | jointAxis | ) |
| inline

Definition at line 96 of file btMultiBodySliderConstraint.h.

## ◆ setPivotInA()

void btMultiBodySliderConstraint::setPivotInA | ( | const btVector3 & | pivotInA | ) |
| inline

Definition at line 56 of file btMultiBodySliderConstraint.h.

## ◆ setPivotInB()

virtual void btMultiBodySliderConstraint::setPivotInB | ( | const btVector3 & | pivotInB | ) |
| inlinevirtual

Reimplemented from btMultiBodyConstraint.

Definition at line 66 of file btMultiBodySliderConstraint.h.

## Member Data Documentation

## ◆ m_frameInA

btMatrix3x3 btMultiBodySliderConstraint::m_frameInA
| protected

Definition at line 31 of file btMultiBodySliderConstraint.h.

## ◆ m_frameInB

btMatrix3x3 btMultiBodySliderConstraint::m_frameInB
| protected

Definition at line 32 of file btMultiBodySliderConstraint.h.

## ◆ m_jointAxis

btVector3 btMultiBodySliderConstraint::m_jointAxis
| protected

Definition at line 33 of file btMultiBodySliderConstraint.h.

## ◆ m_pivotInA

btVector3 btMultiBodySliderConstraint::m_pivotInA
| protected

Definition at line 29 of file btMultiBodySliderConstraint.h.

## ◆ m_pivotInB

btVector3 btMultiBodySliderConstraint::m_pivotInB
| protected

Definition at line 30 of file btMultiBodySliderConstraint.h.

## ◆ m_rigidBodyA

btRigidBody* btMultiBodySliderConstraint::m_rigidBodyA
| protected

Definition at line 27 of file btMultiBodySliderConstraint.h.

## ◆ m_rigidBodyB

btRigidBody* btMultiBodySliderConstraint::m_rigidBodyB
| protected

Definition at line 28 of file btMultiBodySliderConstraint.h.

The documentation for this class was generated from the following files:

- btMultiBodySliderConstraint.h
- btMultiBodySliderConstraint.cpp